'use strict';
var isStickySupported = "boolean" === typeof/./g.sticky, _pattern = function(a) {
  if ("function" === typeof a) {
    return a;
  }
  a = "string" !== typeof a ? a.source : a;
  return isStickySupported ? new RegExp(a, "y") : new RegExp("^(?:" + a + ")", "g");
}, _substr = function(a, d) {
  var c = a.index + d.length, b = a.input.slice(a.index, c);
  if (b === d) {
    return a.index = c, b;
  }
}, _exec = function(a, d) {
  if ("function" === typeof d) {
    return d();
  }
  if (isStickySupported) {
    d.lastIndex = a.index;
    var c = d.exec(a.input);
    a.index = d.lastIndex;
  } else {
    d.lastIndex = 0, c = d.exec(a.input.slice(a.input)), a.index += d.lastIndex;
  }
  return c && c[0];
}, tag = function(a, d) {
  a.tag = d;
  return a;
}, parse = function(a) {
  return function(d) {
    return a({input:d, index:0});
  };
}, _ignored_expression = _pattern(/([\s,]|#[^\n\r]+)+/), ignored = function(a) {
  var d = a.index, c, b = [];
  if (c = _exec(a, _ignored_expression)) {
    return b.push(c), tag(b, "ignored");
  }
  a.index = d;
}, _Name_expression = _pattern(/[_\w][_\d\w]*/), _Name_transform = function(a) {
  return {kind:a.tag, value:a[0]};
}, name = function(a) {
  var d = a.index, c, b = [];
  if (c = _exec(a, _Name_expression)) {
    return b.push(c), _Name_transform(tag(b, "Name"));
  }
  a.index = d;
}, _NullValue_transform = function(a) {
  return {kind:a.tag, value:null};
}, null_ = function(a) {
  var d = a.index, c, b = [];
  if (c = _substr(a, "null")) {
    return b.push(c), _NullValue_transform(tag(b, "NullValue"));
  }
  a.index = d;
}, _BooleanValue_expression = _pattern(/true|false/), _BooleanValue_transform = function(a) {
  return {kind:a.tag, value:"true" === a};
}, bool = function(a) {
  var d = a.index, c, b = [];
  if (c = _exec(a, _BooleanValue_expression)) {
    return b.push(c), _BooleanValue_transform(tag(b, "BooleanValue"));
  }
  a.index = d;
}, _Variable_expression = _pattern(/[$]/), _Variable_transform = function(a) {
  return {kind:a.tag, value:a[0]};
}, variable = function(a) {
  var d = a.index, c, b = [];
  if (_exec(a, _Variable_expression) && (c = name(a))) {
    return b.push(c), _Variable_transform(tag(b, "Variable"));
  }
  a.index = d;
}, _EnumValue_transform = function(a) {
  return {kind:a.tag, value:a[0].value};
}, enum_ = function(a) {
  var d = a.index, c, b = [];
  if (c = name(a)) {
    return b.push(c), _EnumValue_transform(tag(b, "EnumValue"));
  }
  a.index = d;
}, _Number_expression = _pattern(/[-]?\d+/), _Number_expression2 = _pattern(/[.]\d+/), _Number_expression3 = _pattern(/[eE][+-]?\d+/), _Number_transform = function(a) {
  return {kind:1 === a.length ? "IntValue" : "FloatValue", value:a.join("")};
}, number = function(a) {
  var d = a.index, c, b = [];
  if (c = _exec(a, _Number_expression)) {
    return b.push(c), d = a.index, (c = _exec(a, _Number_expression2)) ? b.push(c) : a.index = d, d = a.index, (c = _exec(a, _Number_expression3)) ? b.push(c) : a.index = d, _Number_transform(tag(b, "Number"));
  }
  a.index = d;
}, _StringValue_expression = _pattern(/.*(?=""")/), _StringValue_expression2 = _pattern(/[^"\r\n]*/), _StringValue_transform = function(a) {
  return {kind:a.tag, value:a[0]};
}, string = function(a) {
  var d = a.index, c, b = [];
  var e = a.index, f = b.length;
  if (_substr(a, '"""') && (c = _exec(a, _StringValue_expression)) && (b.push(c), _substr(a, '"""'))) {
    return _StringValue_transform(tag(b, "StringValue"));
  }
  b.length = f;
  a.index = e;
  f = b.length;
  if (_substr(a, '"') && (c = _exec(a, _StringValue_expression2)) && (b.push(c), _substr(a, '"'))) {
    return _StringValue_transform(tag(b, "StringValue"));
  }
  b.length = f;
  a.index = d;
}, _ListValue_transform = function(a) {
  return {kind:a.tag, values:a};
}, list = function(a) {
  var d = a.index, c = [];
  if (_substr(a, "[")) {
    var b = a.index;
    ignored(a) || (a.index = b);
    a: for (;;) {
      var e = a.index;
      if (b = value(a)) {
        c.push(b);
      } else {
        a.index = e;
        break a;
      }
    }
    if (_substr(a, "]")) {
      return b = a.index, ignored(a) || (a.index = b), _ListValue_transform(tag(c, "ListValue"));
    }
  }
  a.index = d;
}, _ObjectField_transform = function(a) {
  return {kind:a.tag, name:a[0], value:a[1]};
}, objectField = function(a) {
  var d = a.index, c, b = [];
  if (c = name(a)) {
    if (b.push(c), c = a.index, ignored(a) || (a.index = c), _substr(a, ":") || (a.index = c), ignored(a) || (a.index = c), c = value(a)) {
      return b.push(c), c = a.index, ignored(a) || (a.index = c), _ObjectField_transform(tag(b, "ObjectField"));
    }
  }
  a.index = d;
}, _ObjectValue_transform = function(a) {
  return {kind:a.tag, fields:a};
}, object = function(a) {
  var d = a.index, c = [];
  if (_substr(a, "{")) {
    var b = a.index;
    ignored(a) || (a.index = b);
    a: for (;;) {
      var e = a.index;
      if (b = objectField(a)) {
        c.push(b);
      } else {
        a.index = e;
        break a;
      }
    }
    if (_substr(a, "}")) {
      return b = a.index, ignored(a) || (a.index = b), _ObjectValue_transform(tag(c, "ObjectValue"));
    }
  }
  a.index = d;
}, _value_transform = function(a) {
  return a[0];
}, value = function(a) {
  var d = a.index, c, b = [], e = b.length;
  a: {
    var f = a.index;
    if (c = null_(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    f = a.index;
    if (c = bool(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    f = a.index;
    if (c = variable(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    f = a.index;
    if (c = string(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    f = a.index;
    if (c = number(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    f = a.index;
    if (c = enum_(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    f = a.index;
    if (c = list(a)) {
      b.push(c);
      break a;
    } else {
      b.length = e, a.index = f;
    }
    if (c = object(a)) {
      b.push(c);
    } else {
      b.length = e;
      a.index = d;
      return;
    }
  }
  d = a.index;
  ignored(a) || (a.index = d);
  return _value_transform(tag(b, "value"));
}, _Argument_transform = function(a) {
  return {kind:a.tag, name:a[0], value:a[1]};
}, arg = function(a) {
  var d = a.index, c, b = [];
  if (c = name(a)) {
    if (b.push(c), c = a.index, ignored(a) || (a.index = c), _substr(a, ":") && (c = a.index, ignored(a) || (a.index = c), c = value(a))) {
      return b.push(c), _Argument_transform(tag(b, "Argument"));
    }
  }
  a.index = d;
}, args = function(a) {
  var d = [], c = a.index;
  _substr(a, "(") || (a.index = c);
  var b = a.index;
  ignored(a) || (a.index = b);
  var e = 0;
  a: for (;; e++) {
    var f = a.index;
    if (b = arg(a)) {
      d.push(b);
    } else {
      if (e) {
        a.index = f;
        break a;
      }
      a.index = c;
    }
  }
  _substr(a, ")") || (a.index = c);
  b = a.index;
  ignored(a) || (a.index = b);
  return tag(d, "ArgumentSet");
}, _Directive_transform = function(a) {
  return {kind:a.tag, name:a[0], arguments:a[1]};
}, directive = function(a) {
  var d = a.index, c, b = [];
  if (_substr(a, "@") && (c = name(a))) {
    return b.push(c), d = a.index, ignored(a) || (a.index = d), d = a.index, (c = args(a)) ? b.push(c) : a.index = d, d = a.index, ignored(a) || (a.index = d), _Directive_transform(tag(b, "Directive"));
  }
  a.index = d;
}, directives = function(a) {
  var d, c = [], b = a.index;
  ignored(a) || (a.index = b);
  a: for (;;) {
    if (b = a.index, d = directive(a)) {
      c.push(d);
    } else {
      a.index = b;
      break a;
    }
  }
  return tag(c, "DirectiveSet");
}, _Field_transform = function(a) {
  var d = 0;
  return {kind:a.tag, alias:"Name" === a[1].kind ? a[d++] : void 0, name:a[d++], arguments:a[d++], directives:a[d++], selectionSet:a[d++]};
}, field = function(a) {
  var d = a.index, c, b = [];
  if (c = name(a)) {
    b.push(c);
    var e = a.index;
    ignored(a) || (a.index = e);
    e = a.index;
    _substr(a, ":") || (a.index = e);
    var f = a.index;
    ignored(a) || (a.index = f);
    (c = name(a)) ? b.push(c) : a.index = e;
    e = a.index;
    ignored(a) || (a.index = e);
    if (c = args(a)) {
      if (b.push(c), c = directives(a)) {
        return b.push(c), e = a.index, (c = selectionSet(a)) ? b.push(c) : a.index = e, _Field_transform(tag(b, "Field"));
      }
    }
  }
  a.index = d;
}, _Type_transform = function(a) {
  var d = "Name" === a[0].kind ? {kind:"NamedType", name:a[0]} : {kind:"ListType", type:a[0]};
  return "!" === a[1] ? {kind:"NonNullType", type:d} : d;
}, type = function(a) {
  var d = a.index, c, b = [], e = b.length;
  a: {
    var f = a.index;
    if (_substr(a, "[")) {
      var g = a.index;
      ignored(a) || (a.index = g);
      if (c = type(a)) {
        if (b.push(c), g = a.index, ignored(a) || (a.index = g), _substr(a, "]")) {
          g = a.index;
          ignored(a) || (a.index = g);
          break a;
        } else {
          b.length = e, a.index = f;
        }
      } else {
        b.length = e, a.index = f;
      }
    } else {
      b.length = e, a.index = f;
    }
    if (c = name(a)) {
      b.push(c);
    } else {
      b.length = e;
      a.index = d;
      return;
    }
  }
  d = a.index;
  (c = _substr(a, "!")) ? b.push(c) : a.index = d;
  d = a.index;
  ignored(a) || (a.index = d);
  return _Type_transform(tag(b, "Type"));
}, _TypeCondition_transform = function(a) {
  return {kind:"NamedType", name:a[0]};
}, typeCondition = function(a) {
  var d = a.index, c, b = [];
  if (_substr(a, "on") && ignored(a) && (c = name(a))) {
    return b.push(c), d = a.index, ignored(a) || (a.index = d), _TypeCondition_transform(tag(b, "TypeCondition"));
  }
  a.index = d;
}, _InlineFragment_transform = function(a) {
  return {kind:a.tag, typeCondition:a[0], directives:a[1], selectionSet:a[2]};
}, inlineFragment = function(a) {
  var d = a.index, c = [];
  if (_substr(a, "...")) {
    var b = a.index;
    ignored(a) || (a.index = b);
    if (b = typeCondition(a)) {
      if (c.push(b), b = directives(a)) {
        if (c.push(b), b = selectionSet(a)) {
          return c.push(b), _InlineFragment_transform(tag(c, "InlineFragment"));
        }
      }
    }
  }
  a.index = d;
}, _FragmentSpread_transform = function(a) {
  return {kind:a.tag, name:a[0], directives:a[1]};
}, fragmentSpread = function(a) {
  var d = a.index, c = [];
  if (_substr(a, "...")) {
    var b = a.index;
    ignored(a) || (a.index = b);
    b = a.index;
    if (_substr(a, "on")) {
      a.index = d;
      return;
    }
    a.index = b;
    if (b = name(a)) {
      if (c.push(b), b = a.index, ignored(a) || (a.index = b), b = directives(a)) {
        return c.push(b), _FragmentSpread_transform(tag(c, "FragmentSpread"));
      }
    }
  }
  a.index = d;
}, _SelectionSet_transform = function(a) {
  return {kind:a.tag, selections:a};
}, selectionSet = function(a) {
  var d = a.index, c, b = [];
  if (_substr(a, "{")) {
    var e = a.index;
    ignored(a) || (a.index = e);
    var f = 0;
    a: for (;; f++) {
      var g = a.index, h = b.length;
      b: {
        e = a.index;
        if (c = inlineFragment(a)) {
          b.push(c);
          break b;
        } else {
          b.length = h, a.index = e;
        }
        e = a.index;
        if (c = fragmentSpread(a)) {
          b.push(c);
          break b;
        } else {
          b.length = h, a.index = e;
        }
        if (c = field(a)) {
          b.push(c);
        } else {
          if (f) {
            a.index = g;
            break a;
          }
          b.length = h;
          a.index = d;
          return;
        }
      }
    }
    if (_substr(a, "}")) {
      return e = a.index, ignored(a) || (a.index = e), _SelectionSet_transform(tag(b, "SelectionSet"));
    }
  }
  a.index = d;
}, _VariableDefinitionDefault_expression = _pattern(/[=]/), _VariableDefinitionDefault_transform = function(a) {
  return a[0];
}, varDefinitionDefault = function(a) {
  var d = a.index, c = [];
  if (_exec(a, _VariableDefinitionDefault_expression)) {
    var b = a.index;
    ignored(a) || (a.index = b);
    if (b = value(a)) {
      return c.push(b), _VariableDefinitionDefault_transform(tag(c, "VariableDefinitionDefault"));
    }
  }
  a.index = d;
}, _VariableDefinition_transform = function(a) {
  return {kind:a.tag, variable:a[0], type:a[1], defaultValue:a[2].tag ? void 0 : a[2], directives:a[2].tag ? a[2] : a[3]};
}, varDefinition = function(a) {
  var d = a.index, c, b = [];
  if (c = variable(a)) {
    if (b.push(c), c = a.index, ignored(a) || (a.index = c), _substr(a, ":") && (c = a.index, ignored(a) || (a.index = c), c = type(a))) {
      b.push(c);
      var e = a.index;
      (c = varDefinitionDefault(a)) ? b.push(c) : a.index = e;
      if (c = directives(a)) {
        return b.push(c), e = a.index, ignored(a) || (a.index = e), _VariableDefinition_transform(tag(b, "VariableDefinition"));
      }
    }
  }
  a.index = d;
}, _VariableDefinitionSet_expression = _pattern(/[(]/), _VariableDefinitionSet_expression2 = _pattern(/[)]/), varDefinitions = function(a) {
  var d = a.index, c = [];
  if (_exec(a, _VariableDefinitionSet_expression)) {
    var b = a.index;
    ignored(a) || (a.index = b);
    var e = 0;
    a: for (;; e++) {
      var f = a.index;
      if (b = varDefinition(a)) {
        c.push(b);
      } else {
        if (e) {
          a.index = f;
          break a;
        }
        a.index = d;
        return;
      }
    }
    if (_exec(a, _VariableDefinitionSet_expression2)) {
      return b = a.index, ignored(a) || (a.index = b), tag(c, "VariableDefinitionSet");
    }
  }
  a.index = d;
}, _FragmentDefinition_transform = function(a) {
  return {kind:a.tag, name:a[0], typeCondition:a[1], directives:a[2], selectionSet:a[3]};
}, fragmentDefinition = function(a) {
  var d = a.index, c = [];
  if (_substr(a, "fragment") && ignored(a)) {
    var b = a.index;
    if (_substr(a, "on")) {
      a.index = d;
      return;
    }
    a.index = b;
    if (b = name(a)) {
      if (c.push(b), ignored(a) && (b = typeCondition(a)) && (c.push(b), b = directives(a))) {
        if (c.push(b), b = selectionSet(a)) {
          return c.push(b), _FragmentDefinition_transform(tag(c, "FragmentDefinition"));
        }
      }
    }
  }
  a.index = d;
}, _OperationDefinition_expression = _pattern(/query|mutation|subscription/), _OperationDefinition_transform = function(a) {
  var d = 1;
  return {kind:a.tag, operation:a[0], name:5 === a.length ? a[d++] : void 0, variableDefinitions:"VariableDefinitionSet" === a[d].tag ? a[d++] : null, directives:a[d++], selectionSet:a[d]};
}, operationDefinition = function(a) {
  var d = a.index, c, b = [], e = a.index;
  ignored(a) || (a.index = e);
  if (c = _exec(a, _OperationDefinition_expression)) {
    if (b.push(c), e = a.index, ignored(a) || (a.index = e), (c = name(a)) ? b.push(c) : a.index = e, e = a.index, ignored(a) || (a.index = e), e = a.index, (c = varDefinitions(a)) ? b.push(c) : a.index = e, c = directives(a)) {
      if (b.push(c), c = selectionSet(a)) {
        return b.push(c), _OperationDefinition_transform(tag(b, "OperationDefinition"));
      }
    }
  }
  a.index = d;
}, _OperationDefinition_transform2 = function(a) {
  return {kind:a.tag, operation:"query", name:void 0, variableDefinitions:[], directives:[], selectionSet:a[0]};
}, queryShorthand = function(a) {
  var d = a.index, c = [];
  var b = a.index;
  ignored(a) || (a.index = b);
  if (b = selectionSet(a)) {
    return c.push(b), _OperationDefinition_transform2(tag(c, "OperationDefinition"));
  }
  a.index = d;
}, _Document_transform = function(a) {
  return a.length ? {kind:a.tag, definitions:a} : void 0;
}, root = function(a) {
  var d = a.index, c, b = [];
  var e = a.index;
  if (c = queryShorthand(a)) {
    return b.push(c), _Document_transform(tag(b, "Document"));
  }
  a.index = e;
  var f = 0;
  a: for (;; f++) {
    e = a.index;
    var g = b.length;
    b: {
      var h = a.index;
      if (c = operationDefinition(a)) {
        b.push(c);
        break b;
      } else {
        b.length = g, a.index = h;
      }
      if (c = fragmentDefinition(a)) {
        b.push(c);
      } else {
        if (f) {
          a.index = e;
          break a;
        }
        b.length = g;
        a.index = d;
        return;
      }
    }
  }
  return _Document_transform(tag(b, "Document"));
}, parse$1 = parse(root);
exports.parse = parse$1

//# sourceMappingURL=graphql-parse-core.js.map
